<?php 
/*
* @package		AceShop
* @copyright	2009-2012 JoomAce LLC, www.joomace.net
* @license		GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

// No Permission
defined('_JEXEC') or die('Restricted access');

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

class ModelToolVirtuemart extends Model {
  	
  	public function importCategories($post){
		$db = JFactory::getDBO();
		$version = self::_getVmVersion();
		$oc_lang_id = (int)$this->config->get('config_language_id');

		if ($version == '1') {
			$query = "SELECT c.category_id, c.category_name, c.category_description, c.category_thumb_image, c.cdate, c.mdate, cd.category_parent_id, cd.category_child_id, c.category_publish AS published FROM #__vm_category AS c, #__vm_category_xref AS cd WHERE c.category_id = cd.category_child_id ORDER BY c.category_id";
		}
		else {
			$query = "SELECT c.virtuemart_category_id AS category_id, ceg.category_name, ceg.category_description, ceg.metadesc, ceg.metakey, c.created_on AS cdate, c.modified_on AS mdate, cc.category_parent_id, cc.category_child_id, c.published "
					."FROM #__virtuemart_categories AS c, #__virtuemart_category_categories AS cc, #__virtuemart_categories_ru_ru AS ceg "
					."WHERE c.virtuemart_category_id = cc.category_child_id "
					."AND c.virtuemart_category_id = ceg.virtuemart_category_id "
					."ORDER BY c.virtuemart_category_id";
		}
		
		$db->setQuery($query);
		$cats = $db->loadAssocList();
		
		if (empty($cats)) {
			echo '<strong>No category to import.</strong>';
			exit;
		}
		
		$i = 0;
		foreach($cats as $cat) {
			if ($version == '1') {
				if ($cat['published'] == 'Y'){
					$cat['published'] = '1';
				}
				else {
					$cat['published'] = '0';
				}
			}
			
			if ($version == '2') {
				$q = "SELECT file_url FROM #__virtuemart_category_medias AS cm, #__virtuemart_medias AS m WHERE cm.virtuemart_media_id = m.virtuemart_media_id AND cm.virtuemart_category_id = ".$cat['category_id'];
				$db->setQuery($q);
				$cat['category_thumb_image'] = $db->loadResult();
			}
			
			$datec = JFactory::getDate($cat['cdate'])->toMySQL();
			$datem = JFactory::getDate($cat['mdate'])->toMySQL();
			
			$cat_image = empty($cat['category_thumb_image']) ? '' : 'data/'.str_replace('images/stories/virtuemart/category/', '', $db->getEscaped($cat['category_thumb_image']));
			$cat_metadesc = empty($cat['metadesc']) ? '' : $db->getEscaped($cat['metadesc']);
			$cat_metakey = empty($cat['metakey']) ? '' : $db->getEscaped($cat['metakey']);
			
			$q = "INSERT INTO `#__aceshop_category` (`category_id`, `image`, `parent_id`, `sort_order`, `date_added`, `date_modified`, `status`) VALUES ('". $cat['category_id']."', '".$cat_image."', '".$cat['category_parent_id']."', '".$i."', '".$datec."', '".$datem."', '".$cat['published']."')";
			$db->setQuery($q);
			$db->query();
			
			$jpcat = "INSERT INTO `#__aceshop_category_description` (`category_id`, `language_id`, `name`, `description`, `meta_description`, `meta_keyword`) VALUES ('". $cat['category_id']."', '".$oc_lang_id."', '".$db->getEscaped(htmlspecialchars($cat['category_name']))."', '". $cat['category_description']."', '". $cat_metadesc."', '". $cat_metakey."')";
			$db->setQuery($jpcat);
			$db->query();
			
			$q = "INSERT INTO `#__aceshop_category_to_store` (`category_id` , `store_id`) VALUES ('".$cat['category_id']."' , '0')";
			$db->setQuery($q);
			$db->query();

			echo 'Importing <i>' . $cat['category_name'] .'</i> : Completed.<br />';
			$i++;
		}
		
		echo '<strong>Categories has been imported successfully.</strong><br />';
		exit;
	}
  	
  	public function importProducts($post) {
		$db = JFactory::getDBO();
		$version = self::_getVmVersion();
		$oc_lang_id = (int)$this->config->get('config_language_id');
		
		if ($version == '1') {
			$query = "SELECT p.product_id, p.product_full_image, p.product_sku, p.product_in_stock, p.cdate, p.mdate, p.product_desc, p.product_weight, p.product_name, p.product_publish AS published, pp.product_price FROM #__vm_product AS p, #__vm_product_price AS pp WHERE p.product_id = pp.product_id";
		}
		else {
			$query = "SELECT p.virtuemart_product_id AS product_id, p.product_sku, p.product_in_stock, p.product_weight, p.published, p.created_on AS cdate, p.modified_on AS mdate, pp.product_price, peg.product_name, peg.product_desc, peg.metadesc, peg.metakey "
					."FROM #__virtuemart_products AS p, #__virtuemart_product_prices AS pp, #__virtuemart_products_ru_ru AS peg "
					."WHERE p.virtuemart_product_id = pp.virtuemart_product_id "
					."AND p.virtuemart_product_id = peg.virtuemart_product_id "
					."ORDER BY p.virtuemart_product_id";
		}
		
		$db->setQuery($query);
		$pros = $db->loadAssocList();
		
		if (empty($pros)) {
			echo '<strong>No product to import.</strong>';
			exit;
		}
		
		foreach($pros as $pro){
			if ($version == '1') {
				if ($pro['published'] == 'Y'){
					$pro['published'] = '1';
				}
				else {
					$pro['published'] = '0';
				}
			
				$q = "SELECT manufacturer_id FROM #__vm_product_mf_xref WHERE product_id = ".$pro['product_id'];
				$db->setQuery($q);
				$man_id = $db->loadResult();
			}
			else {
				$q = "SELECT file_url FROM #__virtuemart_product_medias AS pm, #__virtuemart_medias AS m WHERE pm.virtuemart_media_id = m.virtuemart_media_id AND pm.virtuemart_product_id = ".$pro['product_id'];
				$db->setQuery($q);
				$pro['product_full_image'] = $db->loadResult();
			
				$q = "SELECT virtuemart_manufacturer_id FROM #__virtuemart_product_manufacturers WHERE virtuemart_product_id = ".$pro['product_id'];
				$db->setQuery($q);
				$man_id = $db->loadResult();
			}
			
			$cdate = JFactory::getDate($pro['cdate'])->toMySQL();
			$mdate = JFactory::getDate($pro['mdate'])->toMySQL();
			
			$pro_image = empty($pro['product_full_image']) ? '' : 'data/'.str_replace('images/stories/virtuemart/product/', '', $db->getEscaped($pro['product_full_image']));
			$pro_metadesc = empty($pro['metadesc']) ? '' : $db->getEscaped($pro['metadesc']);
			$pro_metakey = empty($pro['metakey']) ? '' : $db->getEscaped($pro['metakey']);
			
			$q = "INSERT INTO `#__aceshop_product` (`product_id`, `model`, `sku`, `location`, `quantity`, `stock_status_id`, `image`, `manufacturer_id`, `shipping`, `price`, `tax_class_id`, `date_available`, `weight`, `weight_class_id`, `length`, `width`, `height`, `status`, `date_added`, `date_modified`, `viewed`) VALUES ('".$pro['product_id']."', '".$pro['product_sku']."', '".$pro['product_sku']."', '', '".$pro['product_in_stock']."', '7', '".$pro_image."', '".$man_id."', '1', '".$db->getEscaped($pro['product_price'])."', '', CURDATE(), '".$pro['product_weight']."', '0', '0.00', '0.00', '0.00',  '".$pro['published']."', '".$cdate."', '".$mdate."', '0')";
			$db->setQuery($q);
			$db->query();
			
			$q = "INSERT INTO `#__aceshop_product_description` (`product_id`, `language_id`, `name`, `description`, `meta_description`, `meta_keyword`) VALUES ('".$pro['product_id']."' , '".$oc_lang_id."' , '".$db->getEscaped(htmlspecialchars($pro['product_name']))."' , '".$db->getEscaped(htmlspecialchars($pro['product_desc']))."', '". $pro_metadesc."', '". $pro_metakey."')";
			$db->setQuery($q);
			$db->query();
			
			$q = "INSERT INTO `#__aceshop_product_to_store` (`product_id` , `store_id`) VALUES ('".$pro['product_id']."' , '0')";
			$db->setQuery($q);
			$db->query();
	    
			echo 'Importing <i>' . $pro['product_name'] .'</i> : Completed.<br />';
		}
		
		if ($version == '1') {
			$q = "SELECT product_id, category_id FROM #__vm_product_category_xref";
		}
		else {
			$q = "SELECT virtuemart_product_id AS product_id, virtuemart_category_id AS category_id FROM #__virtuemart_product_categories";
		}
		
		$db->setQuery($q);
		$results = $db->loadAssocList();
		
		if (!empty($results)) {
			foreach($results as $ptcs) {
				$q = "INSERT INTO `#__aceshop_product_to_category` (`product_id`, `category_id`) VALUES ('".$ptcs['product_id']."', '".$ptcs['category_id']."');";
				$db->setQuery($q);
				$db->query();
			}
		}

		echo '<strong>Products has been imported successfully.</strong><br />';
		exit;
	}
	
	public function importManufacturers($post) {
		$db = JFactory::getDBO();
		$version = self::_getVmVersion();
		$oc_lang_id = (int)$this->config->get('config_language_id');
		
		if ($version == '1') {
			$query = "SELECT manufacturer_id, mf_name FROM `#__vm_manufacturer`";
		}
		else {
			$query = "SELECT virtuemart_manufacturer_id AS manufacturer_id, mf_name FROM `#__virtuemart_manufacturers_ru_ru`";
		}
		
		$db->setQuery($query);
		$mans = $db->loadAssocList();
		
		if (empty($mans)) {
			echo '<strong>No manufacturer to import.</strong>';
			exit;
		}
		
		foreach($mans as $man) {
			if ($version == '2') {
				$q = "SELECT file_url FROM #__virtuemart_manufacturer_medias AS mm, #__virtuemart_medias AS m WHERE mm.virtuemart_media_id = m.virtuemart_media_id AND mm.virtuemart_manufacturer_id = ".$man['manufacturer_id'];
				$db->setQuery($q);
				$man['image'] = $db->loadResult();
			}
			
			$man_image = empty($man['image']) ? '' : 'data/'.str_replace('images/stories/virtuemart/manufacturer/', '', $db->getEscaped($man['image']));
			
			$q = "INSERT INTO `#__aceshop_manufacturer` (`manufacturer_id`, `name`, `image`) VALUES ('".$man['manufacturer_id']."', '".$db->getEscaped(htmlspecialchars($man['mf_name']))."', '".$man_image."');";
			$db->setQuery($q);
			$db->query();
			
			$q = "INSERT INTO `#__aceshop_manufacturer_to_store` (`manufacturer_id` , `store_id`) VALUES ('".$man['manufacturer_id']."' , '0')";
			$db->setQuery($q);
			$db->query();
			
			echo 'Importing <i>' . $man['mf_name'] .'</i> : Completed.<br />';
		}
		
		echo '<strong>Manufacturers has been imported successfully.</strong><br />';
		exit;
	}
	
	public function copyImages($post) {
		$version = self::_getVmVersion();
		
		if ($version == '1') {
			$vm_cats = JPATH_SITE.'/components/com_virtuemart/shop_image/category/';
			$vm_pros = JPATH_SITE.'/components/com_virtuemart/shop_image/product/';
			
			self::_copyImages($vm_cats);
			self::_copyImages($vm_pros);
		}
		else {
			$vm_cats = JPATH_SITE.'/images/stories/virtuemart/category/';
			$vm_pros = JPATH_SITE.'/images/stories/virtuemart/product/';
			$vm_mans = JPATH_SITE.'/images/stories/virtuemart/manufacturer/';
			$vm_shis = JPATH_SITE.'/images/stories/virtuemart/shipment/';
			$vm_vens = JPATH_SITE.'/images/stories/virtuemart/vendor/';
			
			self::_copyImages($vm_cats);
			self::_copyImages($vm_pros);
			self::_copyImages($vm_mans);
			self::_copyImages($vm_shis);
			self::_copyImages($vm_vens);
		}
	  
		echo '<strong>Images has been copied successfully.</strong>';
		exit;
	}
	
	public function _copyImages($dir) {
		foreach (glob($dir . "*") as $filename) {
			if (JFolder::exists($filename)) {
				continue;
			}
			
			if (!JFile::copy($filename, DIR_IMAGE . 'data/' . basename($filename))){
				echo 'Failed to copy <i>' . $filename . '</i> to image directory.<br />';
			}
			else {
				echo 'Copying <i>' . $filename . '</i> : Completed.<br />';
			}
		}
	}
	
	public function _getVmVersion() {
		static $version;
		
		if (!isset($version)) {
			$v = AceShop::getClass('base')->getXmlText(JPATH_ADMINISTRATOR.'/components/com_virtuemart/virtuemart.xml', 'version');
			
			$compare_1 = version_compare($v, '2.0.0');
			$version = ($compare_1 == -1 ? '1' : '2');
		}
		
		return $version;
	}
}